/**************************************
This software was developed at the National Institute of Standards 
and Technology by employees of the Federal Government in the course 
of their official duties. Pursuant to title 17 Section 105 of the 
United States Code this software is not subject to copyright 
protection and is in the public domain. 
 
We would appreciate acknowledgement if the software is used.


Disclaimer:
-----------
There is no warranty, implied or otherwise, of any sort, nor any
guarantee of accuracy or correctness for any of the code in this
release.

/**************************************
File:802.h
contains the definition of global variables and constants and functions
author: Amir Soltanian
Last update:  4/23/01
*************************************/

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#define IB1 1  //shift register
#define IB3 4  //shift register
#define IB20 524288  //shift register
#define MASK IB3     //shift register
#define palen 160    //packet length=160 bit
#define hf 1./3.     //modulation index
#define PI 3.141592654
#define INTPHASE 0   // initialize phase for GFSK
#define ALPHA_N_1 0  // initialize bit for GFSK
#define RSLENGTH 33  // length of the receiver's bandpass filter 
#define DLY 31       // total delay of the system 
#define Ns 44        //  samples per  Bluetooth bit bit
#define Nscck 4      // samples per cck bit
 

int   Error( void );
void  gfsk_modulator(int, float);
void  DataGen( void );
void  IQModRead(short int n);
void  hrTable(void);
void  CodeTable(void);
void  NoiseGen( void);
void  receiver(short int n);
void  receiver2(short int n);
void  receiver3(short int n);
void  receiver256(short int n);
void  BTpacket(void);
void  BTInt(double df,double bBT, short int n);
void  TxCCK(short int n);
void  TxCCK256(short int n);
void  RSRaisedCosine(void);
void  Packet802(void);
 
void  AddChips(void);
      
extern int    x1,x2,x3,x4,x5,x6;//variables used for generating uniform r.v.
extern unsigned int iseed;
extern unsigned short int packet802[palen/16+1],packet[palen], decod[palen/16+1] ;
extern short int Intpacket[palen/16+1],Ipacket[palen];
extern short int Ipacket802[palen],dpacket802[palen];
extern short int BTIntpacket[palen/16+1],BTIpacket[palen];
extern double hrsrc[RSLENGTH];
extern double Inphasecck[11*8*Nscck],Quadcck[11*8*Nscck];
extern double n0;
extern double CInphase[256][8],CQuad[256][8];

		